﻿/**

History:
	$(HIST_VER 1.000,
		$(HIST_CHG package, nemuxi.dll, negui.file)
	)
	$(HIST_VER 1.00β11,
		$(HIST_CHG nemuxi.utility, TSubClass, nemuxi.dll)
	)
*/
module etc.negui.file.dll;

debug import std.stdio: wl = writefln;
debug(dll) void main() {}

import std.contracts;
import std.traits;

import win32.windows;

import etc.negui.system.base;
import etc.negui.file.file;

///
class DllException: NeGuiException {
	mixin MixInNeGuiException;
}

/**
*/
class DLL: HandleRaii {
	protected alias Handle hDLL;
	mixin KillResource!("DLL", hDLL, FreeLibrary, 0);
	mixin MixInHandleRaiiNotDuplicate;
	mixin MixInHandleRaiiNotDup;

	///
	this(in Text Path) {
		hDLL = enforce(LoadLibrary(Path.ptr), new DllException(Text("%s, Path -> %s", ERR.toText, Path)));
		super(hDLL, true);
	}

	/**
	History:
		$(HIST_VER 1.110,
			$(HIST_P Text.toStringzの変更に伴う修正。)
		)
		$(HIST_VER 1.00β16,
			$(HIST_S Tがよろしくない場合に出力していた文言の出力方式を若干変更。)
		)
	*/
	const RET address(RET, T)(in T Address)
	if(IsText!(T) || isIntegral!(T))
	{
		static if(IsText!(T)) {
			return cast(RET)GetProcAddress(hDLL, Address.toStringz!(char));
		} else {
			static assert(isIntegral!(T));
			assert(Address <= ushort.max);
			return cast(RET)GetProcAddress(hDLL, cast(LPCSTR)Address);
		}
	}

	/**
	History:
		$(HIST_VER 1.110,
			$(HIST_NEW)
		)
	*/
	const Text path() {
		return FILE.modulePath(hDLL);
	}
}



