﻿/**
read me.

$(DEF_LIST
	$(DEF_TERM はじめに)
	$(DEF_DESC 
		この文書はNeGui及びそれに付随するものに対するドキュメントです。
		readme.txtな役割をするものだと認識してください。
	)

	$(DEF_TERM NeGuiとは)
	$(DEF_DESC 
		D用Window APIへ薄皮一枚のラッパー。
		Windows APIを使用したプログラミングの経験のある人が対象。
	)
	$(DEF_DESC 
		もともとはﾈﾑぃ専用GUIクラスだったんだけどどんどんおかしな方向に走り出して今の姿に。
		本来etc.negui.fileみたいなpackageは全く考慮してなかったし。
	)
	$(DEF_DESC 
		バグやら修正やら追加やらがあれば$(LINK_TITLE http://www.usamimi.info/~wokonomono/, サイト)かメール($(LINK_MAIL wokonomono@gmail.com))に連絡あれば嬉しいです。
	)

	$(DEF_TERM 使用準備)
	$(DEF_DESC 
		$(LIST_UNORDERED 
			$(LIST_ITEM $(LINK_TITLE http://www.digitalmars.com/, Digital Mars D compiler 2.046))
			$(LIST_ITEM $(LINK_TITLE http://www.dsource.org/projects/build/, bud 3.04))
			$(LIST_ITEM $(LINK_TITLE http://www.dsource.org/projects/bindings/wiki/WindowsApi, Bindings for the Windows API))
		)
	)
	$(DEF_DESC 
		Bindings for the Windows APIのwin32\shlobj.dを一部修正する必要があります。
		* ----------------------------------------
		* module win32.shlobj;
		* pragma(lib, "shell32.lib");
		*
		* // TODO: fix bitfields
		* // TODO: CMIC_VALID_SEE_FLAGS
		* // SHGetFolderPath in shfolder.dll on W9x, NT4, also in shell32.dll on W2K
		*
		* import win32.commctrl, win32.ole2, win32.shlguid, win32.shellapi;
		* private import win32.prsht, win32.unknwn, win32.w32api, win32.winbase,
		*   win32.winnt, win32.winuser, win32.wtypes, win32.objfwd, win32.objidl;
		* private import win32.winnetwk; // for NETRESOURCE
		*
		*
		* import win32.oaidl; //@追加
		* ...
		* ---------------------------------------
		上記の「@追加」の一行を追加してください。
		Windows SDKも忘れずに。<br />
		あと引数がinoutになっている部分をrefに置き換える必要もあります。
		これはコンパイル時に引っ掛かるのでそのときに修正してください。
	)
	$(DEF_DESC 
		budは無くてもいいけどその場合は下記versionをくっつけてください。
		$(PREFORMATTED 
		*dmd @@@.d -version=WindowsXP -version=Unicode -version=IE7
		)
		versionそのものは環境に合わせてください。

		あと.defファイルに
		$(PREFORMATTED 
		*EXETYPE NT
		*SUBSYSTEM WINDOWS,5.0
		)
		するのも忘れないように。
		値はターゲットに合わせください。

		よくわかんない場合は素直にbud使ってください。
		budを使う場合はetc.negui.bulidで最低限のversionは設定しているので特に何も考えることなく使用できます。
	)
	$(DEF_DESC 
		とまぁ本来ならこれでコンパイル出来るんだろうけど実際問題できません。
		リンカやらスタティックライブラリの知識が皆無なのでなんとも言えませんが取り敢えずの回避策はbud @@@.d -fullすれば動きます。
	)

	$(DEF_TERM 識別子の指針)
	$(DEF_DESC 
		$(LIST_UNORDERED 
			$(LIST_ITEM 
				$(TABLE
					$(TABLE_CAPTION ※Dのスタイルとは合わないけれども。)
					$(TABLE_HEAD
						$(TABLE_ROW
							$(TABLE_COL_HEAD 識別子)
							$(TABLE_COL_HEAD 方針)
						)
					)
					$(TABLE_BODY
						$(TABLE_ROW
							$(TABLE_COL_HEAD 関数名)
							$(TABLE_COL_DATA 各単語の先頭は大文字。ただし配列への糖衣構文は先頭小文字)
						)
						$(TABLE_ROW
							$(TABLE_COL_HEAD メソッド)
							$(TABLE_COL_DATA Dの関数の書き方)
						)
						$(TABLE_ROW
							$(TABLE_COL_HEAD 戻り値が構造体)
							$(TABLE_COL_DATA でっかくなければそのまま、でかければref。Textに関しては絶賛迷走中。)
						)
						$(TABLE_ROW
							$(TABLE_COL_HEAD クラス)
							$(TABLE_COL_DATA 各単語の先頭を大文字)
						)
						$(TABLE_ROW
							$(TABLE_COL_HEAD インターフェイス)
							$(TABLE_COL_DATA
								多重継承時にクラスなのかインターフェイスなのか明確にするため先頭に'I'、各単語の先頭を大文字
								$(INSERT
									あれなんだね、インターフェイスって継承元クラスのあとにしかつけられないんだね。
									これだったら別に'I'着けなくてもいいじゃないかと思ったけど着ける方針でいく。
								)
							)
						)
						$(TABLE_ROW
							$(TABLE_COL_HEAD 構造体・共用体)
							$(TABLE_COL_DATA 全部大文字でアンダースコア '__' は使用しない)
						)
						$(TABLE_ROW
							$(TABLE_COL_HEAD 構造体・共用体メンバ)
							$(TABLE_COL_DATA メソッドと同じ)
						)
						$(TABLE_ROW
							$(TABLE_COL_HEAD クラス・構造体・共用体のprivate, protectedメンバ)
							$(TABLE_COL_DATA
								各単語の先頭を大文字
								$(INSERT
									'__'をつけるように方向転換しようかと考え中。
								)
							)
						)
						$(TABLE_ROW
							$(TABLE_COL_HEAD 定数・列挙体・列挙型メンバ)
							$(TABLE_COL_DATA 全部大文字)
						)
						$(TABLE_ROW
							$(TABLE_COL_HEAD Windows API - 構造体)
							$(TABLE_COL_DATA 頻繁に使うもので定数とかあるやつはラップ)
						)
					)
				)
			)
			$(LIST_ITEM 
				GUIに関係なさげなWindows APIもOK。
			)
			$(LIST_ITEM 
				PhobosでできることはPhobosで。
			)
			$(LIST_ITEM 
				内部でメモリを拡張したりするものはその値を指定可能に。
			)
		)
	)
)

Note:
	parentなのかownerなのか、統一させたい。

Authors:
	$(AUTHORS
		$(AUTHOR
			sk, http://www.usamimi.info/~wokonomono/, wokonomono@gmail.com
		)
	)

License:
	$(LINK_TITLE http://www.kmonos.net/nysl/, NYSL)

Date:
	History参照。

Version:
	History参照。

History:
	$(HIST_VER 1.110 $(HIST_DATE 2010/05/16),
		$(HIST_O [package] etc.negui.wrapper等追加。)
	)
	$(HIST_VER 1.101 $(HIST_DATE 2010/05/04),
		$(HIST_O negui.ddocの大幅変更、それに伴い関連部分の変更。)
	)
	$(HIST_VER 1.000 $(HIST_DATE 2010/05/02),
		$(HIST_O 色々変更。)
		$(HIST_O ﾈﾑぃから分離。)
		$(HIST_O 独立して公開。)
	)
*/
module etc.negui.readme;

debug import std.stdio: wl = writefln;
debug(readme) void main() {}


