﻿/**
Windowsエラー

とりあえずERR構造体が何とかしてくれる。

$(DDOC_COMMENT もう統合済み
Bugs:
	NeGuiに統合すべき。
)

History:
	$(HIST_VER 1.00β20,
		$(HIST_S package, module, その他色々変更。)
	)
*/
module etc.negui.system.error;

debug(error) void main() {}

import std.windows.syserror;

import win32.windows;

import etc.negui.system.utility.array; // Error: struct etc.negui.system.text.Text no size yet for forward reference
import etc.negui.system.text;
import etc.negui.system.time;

/**
エラー表示のためのnamespaceっぽいの。

ErrだとNeGuiの構造体じゃなくなるからERRORにしてみたらwin32.wingdiとがっちんこ。
Errorにするとこれまた構造体じゃなくなるからERRで。

History:
	$(HIST_VER 1.110,
		$(HIST_D text削除。)
	)
	$(HIST_VER 1.032,
		$(HIST_S 名前変更。)
		$(HIST_S I/Fを若干変更。)
	)
*/
static struct ERR {
static:
	/// エラーコード設定。
	void code(DWORD ErrCode) {
		SetLastError(ErrCode);
	}
	/// エラーコード取得。
	DWORD code() {
		return GetLastError();
	}

	/**
	非エラーのエラーコード取得。
	
	History:
		$(HIST_VER 1.032,
			$(HIST_NEW)
		)
	*/
	DWORD noError() {
		return NO_ERROR;
	}
	alias noError init;
	
	/// エラーコード初期化。
	void initialize() {
		code(init);
	}

	
	/**
	エラー文字列を取得。
	
	History:
		$(HIST_VER 1.032,
			$(HIST_CHG 名前, text, toText)
		)
	*/
	Text toText(DWORD Code=code()) {
		return sysErrorString(Code).toText;
	}
	/+
	/// ditto
	deprecated alias toText text;
	+/
	
	/// ditto
	string toString(DWORD Code=code()) {
		return sysErrorString(Code);
	}
}


