﻿/**
Application Desktop Toolbar

URI:
	参考というよりかはコピペ

	$(LINK_TITLE http://msdn.microsoft.com/ja-jp/library/cc144177%28VS.85%29.aspx, アプリケーション デスクトップ ツール バーの使用)

History:
	$(HIST_VER 1.110,
		$(HIST_S ソース手入れ。)
	)
	$(HIST_VER 1.060,
		$(HIST_S ソース手入れ。)
	)
*/
module etc.negui.window.adtb;

debug import std.stdio: wl = writefln;
debug(adtb) void main() {}

import win32.windows;

import etc.negui.system.base;
import etc.negui.window.window;
import etc.negui.environ.system;

/**
History:
	$(HIST_VER 1.110,
		$(HIST_NEW)
	)
*/
struct APPDESKTOPTOOLBARDATA {
	APPBARDATA AppBarData;
	mixin(SMixInStructHiddenOriginal!(APPBARDATA)(q{AppBarData}));

	void initialize() {
		AppBarData.cbSize = AppBarData.sizeof;
	}
	@property const Window window() {
		return cast(Window)GetGui(AppBarData.hWnd);
	}
	@property void window(in Window wnd) {
		AppBarData.hWnd = wnd ? wnd(): null;
	}
	
	mixin(SMixInStructGetSet!(MESSAGETYPE)("message", q{AppBarData.uCallbackMessage}));
	
	/**
	History:
		$(HIST_VER 1.110,
			$(HIST_CHG 位置, ApplicationDesktopToolBar, APPDESKTOPTOOLBARDATA)
			$(HIST_CHG 名前変更, POSITION, EDGE)
		)
		$(HIST_VER 1.021,
			$(HIST_S 名前変更。)
		)
	*/
	enum EDGE {
		LEFT   = ABE_LEFT,   /// 左
		TOP    = ABE_TOP,    /// 上
		RIGHT  = ABE_RIGHT,  /// 右
		BOTTOM = ABE_BOTTOM, /// 下
	}
	mixin(SMixInStructGetSet!(EDGE)("edge", q{AppBarData.uEdge}));

	mixin(SMixInStructGetSet!(void*)("data", q{AppBarData.lParam}));
}


/**
アプリケーションデスクトップツールバー登録。

Deprecated:
	ApplicationDesktopToolBar.Registを使用。

History:
	$(HIST_VER 1.110,
		$(HIST_MSG Deprecatedに。)
	)
*/
deprecated private bool RegistAppDeskTopToolBar(HWND hWnd, UINT CallBackMessage) {
	APPBARDATA AppBarData;

	AppBarData.cbSize           = AppBarData.sizeof;
	AppBarData.hWnd             = hWnd;
	AppBarData.uCallbackMessage = CallBackMessage;

	return SHAppBarMessage(ABM_NEW, &AppBarData)
		? true
		: false;
}
/**
アプリケーションデスクトップツールバー登録解除。

Deprecated:
	ApplicationDesktopToolBar.UnRegistを使用。

History:
	$(HIST_VER 1.110,
		$(HIST_MSG Deprecatedに。)
	)
*/
deprecated private bool UnRegistAppDeskTopToolBar(HWND hWnd) {
	APPBARDATA AppBarData;

	AppBarData.cbSize           = AppBarData.sizeof;
	AppBarData.hWnd             = hWnd;

	return SHAppBarMessage(ABM_REMOVE, &AppBarData)
		? true
		: false;
}

/**

History:
	$(HIST_VER 1.110,
		$(HIST_D ABE削除。)
		$(HIST_D SetAppBarData削除。)
		$(HIST_D querySize削除。)
	)
*/
class ApplicationDesktopToolBar: Raii {
	protected Window window;
	/**
	History:
		$(HIST_VER 1.110,
			$(HIST_CHG 型, UINT, MESSAGETYPE)
		)
	*/
	protected const MESSAGETYPE MessageID;

	///
	enum EVENT: MESSAGETYPE {
		STATECHANGE   = ABN_STATECHANGE,   /// タスクバーの設定が変わった。
		POSCHANGED    = ABN_POSCHANGED,    /// サイズ変更。
		FULLSCREENAPP = ABN_FULLSCREENAPP, /// フルスクリーン状態の変更。
		WINDOWARRANGE = ABN_WINDOWARRANGE, /// 
	}


	
	override protected void Kill() {
		//UnRegistAppDeskTopToolBar(window());
		UnRegist();
	}

	///
	enum MESSAGE {
		NEW              = ABM_NEW,              /// 
		REMOVE           = ABM_REMOVE,           /// 
		QUERYPOS         = ABM_QUERYPOS,         /// 
		SETPOS           = ABM_SETPOS,           /// 
		GETSTATE         = ABM_GETSTATE,         /// 
		GETTASKBARPOS    = ABM_GETTASKBARPOS,    /// 
		ACTIVATE         = ABM_ACTIVATE,         /// 
		GETAUTOHIDEBAR   = ABM_GETAUTOHIDEBAR,   /// 
		SETAUTOHIDEBAR   = ABM_SETAUTOHIDEBAR,   /// 
		WINDOWPOSCHANGED = ABM_WINDOWPOSCHANGED, /// 
		SETSTATE         = ABM_SETSTATE,         /// 
	}

	///
	static UINT send(MESSAGE Message, ref APPDESKTOPTOOLBARDATA AppDesktopToolbar) {
		return SHAppBarMessage(Message, AppDesktopToolbar.ptr);
	}

	protected {
		bool Regist() {
			APPDESKTOPTOOLBARDATA AppBarData;

			AppBarData.initialize;
			AppBarData.window  = window;
			AppBarData.message = MessageID;

			return cast(bool)send(MESSAGE.NEW, AppBarData);
		}
		bool UnRegist() {
			APPDESKTOPTOOLBARDATA AppBarData;

			AppBarData.initialize;
			AppBarData.window  = window;

			return cast(bool)send(MESSAGE.REMOVE, AppBarData);
		}
	}
	
	/**
	History:
		$(HIST_VER 1.110,
			$(HIST_CHG MessageIDの型, UINT, MESSAGETYPE)
		)
	*/
	this(Window window, MESSAGETYPE MessageID) {
		super(true);
		
		this.window    = window;
		this.MessageID = MessageID;

		//RegistAppDeskTopToolBar(window(), MessageID);
		Regist();
	}

	/+
	/**
	History:
		$(HIST_VER 1.021,
			$(HIST_S 名前変更。)
		)
	*/
	static enum POSITION {
		LEFT   = ABE_LEFT,   /// 左
		TOP    = ABE_TOP,    /// 上
		RIGHT  = ABE_RIGHT,  /// 右
		BOTTOM = ABE_BOTTOM, /// 下
	}
	+/
	alias APPDESKTOPTOOLBARDATA.EDGE POSITION;
	//deprecated alias POSITION ABE;
	
	/**
	History:
		$(HIST_VER 1.110,
			$(HIST_CHG 名前, Position, Edge)
			$(HIST_CHG 型, Position, APPDESKTOPTOOLBARDATA.EDGE)
		)
	*/
	protected APPDESKTOPTOOLBARDATA.EDGE Edge;
	alias Edge Position;
	
	/**
	History:
		$(HIST_VER 1.110,
			$(HIST_CHG 名前, position, edge)
			$(HIST_CHG 戻り値の型, Position, APPDESKTOPTOOLBARDATA.EDGE)
		)
	*/
	const APPDESKTOPTOOLBARDATA.EDGE edge() {
		return Edge;
	}
	alias edge position;

	/**
	History:
		$(HIST_VER 1.110,
			$(HIST_CHG 名前, position, edge)
			$(HIST_CHG Posの型, POSITION, APPDESKTOPTOOLBARDATA.EDGE)
			$(HIST_CHG 引数, Pos, Edge)
		)
	*/
	void edge(APPDESKTOPTOOLBARDATA.EDGE Edge) {
		this.Edge = Edge;

		SIZE Size;
		APPDESKTOPTOOLBARDATA AppBarData;
		//APPBARDATA AppBarData;

		//SetAppBarData(&AppBarData);
		AppBarData.initialize;
		AppBarData.window = window;
		
		//QuerySize(Size);
		Size = window.itemSize;
		QueryPosition(this.Edge, Size, AppBarData);

		//最終的なサイズをシステムに伝える
		//SHAppBarMessage(ABM_SETPOS, &AppBarData);
		send(MESSAGE.SETPOS, AppBarData);

		//ウインドウの大きさを変える
		window.move(
			AppBarData.rc.left,
			AppBarData.rc.top, 
			AppBarData.rc.right  - AppBarData.rc.left,
			AppBarData.rc.bottom - AppBarData.rc.top,
			true
		);
	}
	alias edge position;
	
	/**
	History:
		$(HIST_VER 1.110,
			$(HIST_CHG 名前, queryPos, QueryPosition)
			$(HIST_CHG 属性, public, protected)
			$(HIST_CHG Posの型, POSITION, APPDESKTOPTOOLBARDATA.EDGE)
			$(HIST_CHG 引数, Pos, Edge)
			$(HIST_P 内部をごにょごにょ変更。)
			$(HIST_CHG Sizeの型, SIZE*, ref SIZE)
			$(HIST_CHG AppBarDataの型, APPBARDATA*, ref APPDESKTOPTOOLBARDATA)
		)
	*/
	protected void QueryPosition(APPDESKTOPTOOLBARDATA.EDGE Edge, ref SIZE Size, ref APPDESKTOPTOOLBARDATA AppBarData) {
		/+
		AppBarData.uEdge = Edge; 

		AppBarData.rc.left   = 0;
		AppBarData.rc.top    = 0;
		AppBarData.rc.bottom = GetSystemMetrics(SM_CYSCREEN);
		AppBarData.rc.right  = GetSystemMetrics(SM_CXSCREEN);
		+/
		AppBarData.edge = Edge;

		auto ScreenSize=METRIC.screen();
		AppBarData.rc.left   = 0;
		AppBarData.rc.top    = 0;
		AppBarData.rc.bottom = ScreenSize.cx;//GetSystemMetrics(SM_CYSCREEN);
		AppBarData.rc.right  = ScreenSize.cy;//GetSystemMetrics(SM_CXSCREEN);
		

		with(APPDESKTOPTOOLBARDATA.EDGE) final switch(Edge) {
			case LEFT:
				AppBarData.rc.right=AppBarData.rc.left+Size.cx;
				break;
			case TOP:
				AppBarData.rc.bottom=AppBarData.rc.top+Size.cy;
				break;
			case RIGHT:
				AppBarData.rc.left=AppBarData.rc.right-Size.cx;
				break;
			case BOTTOM:
				AppBarData.rc.top=AppBarData.rc.bottom-Size.cy;
				break;
			/+
			default:
				assert(false);
			+/
		}

		//システムにサイズを調整してもらう
		//SHAppBarMessage(ABM_QUERYPOS, AppBarData); 
		send(MESSAGE.QUERYPOS, AppBarData);

		with(APPDESKTOPTOOLBARDATA.EDGE) final switch(Edge) {
			case LEFT:
				AppBarData.rc.right = AppBarData.rc.left + Size.cx;
				break;
			case RIGHT:
				AppBarData.rc.left = AppBarData.rc.right - Size.cx;
				break;
 			case TOP:
				AppBarData.rc.bottom = AppBarData.rc.top + Size.cy;
				break;
			case BOTTOM:
				AppBarData.rc.top = AppBarData.rc.bottom - Size.cy;
				break;
			/+
			default:
				assert(false);
			+/
		}
	}
	/+
	/**
	*/
	deprecated protected void querySize(ref SIZE Size) {
		Size = window.itemSize();
	}
	+/

	/+
	deprecated protected void SetAppBarData(APPBARDATA* AppBarData)
	in {
		assert(AppBarData);
	}
	body {
		AppBarData.cbSize = AppBarData.sizeof;
		AppBarData.hWnd   = window();
		AppBarData.lParam = 0;
	}
	+/

	/// WM_ACTIVATE
	void onActivate() {
		//APPBARDATA AppBarData;
		APPDESKTOPTOOLBARDATA AppBarData;

		//SetAppBarData(&AppBarData);
		AppBarData.initialize;
		AppBarData.window = window;

		//SHAppBarMessage(ABM_ACTIVATE, &AppBarData);
		send(MESSAGE.ACTIVATE, AppBarData);
	}
	/// WM_WINDOWPOSCHANGED
	void onWindowPosChanged() {
		//APPBARDATA AppBarData;
		APPDESKTOPTOOLBARDATA AppBarData;

		//SetAppBarData(&AppBarData);
		AppBarData.initialize;
		AppBarData.window = window;

		//SHAppBarMessage(ABM_WINDOWPOSCHANGED, &AppBarData);
		send(MESSAGE.WINDOWPOSCHANGED, AppBarData);
	}
}

